// KeyDownView.cpp : implementation of the CKeyDownView class
//

#include "stdafx.h"
#include "KeyDown.h"

#include "KeyDownDoc.h"
#include "KeyDownView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKeyDownView

IMPLEMENT_DYNCREATE(CKeyDownView, CView)

BEGIN_MESSAGE_MAP(CKeyDownView, CView)
	//{{AFX_MSG_MAP(CKeyDownView)
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyDownView construction/destruction

CKeyDownView::CKeyDownView()
{
	// TODO: add construction code here

	m_stringArray.SetSize(20);
	m_stringCount = 0;
	m_keyDownCount = 0;
}

CKeyDownView::~CKeyDownView()
{
}

BOOL CKeyDownView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CKeyDownView drawing

void CKeyDownView::OnDraw(CDC* pDC)
{
	CKeyDownDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here

	for (int x=0; x<20; ++x)
	{
		CString s = m_stringArray.GetAt(x);
		pDC->TextOut(20, x*20, s);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CKeyDownView diagnostics

#ifdef _DEBUG
void CKeyDownView::AssertValid() const
{
	CView::AssertValid();
}

void CKeyDownView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CKeyDownDoc* CKeyDownView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CKeyDownDoc)));
	return (CKeyDownDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CKeyDownView message handlers

void CKeyDownView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	char c[80];
	wsprintf(c, "WM_KEYDOWN #%d   Char: %c   Repeat: %d   \
Extended: %d   Previous: %d",
        m_keyDownCount++, nChar, nRepCnt, (nFlags >> 8) & 0x01,
		(nFlags >> 14) & 0x01);

	CString str(c);

	if (m_stringCount < 20)
		m_stringArray.SetAt(m_stringCount++, str);
	else
	{
		for (int x=0; x<19; ++x)
		{
			CString s = m_stringArray.GetAt(x+1);
			m_stringArray.SetAt(x, s);
		}
		m_stringArray.SetAt(19, str);
	}

	Invalidate();

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CKeyDownView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default

	m_keyDownCount = 0;

	if (m_stringCount < 20)
		m_stringArray.SetAt(m_stringCount++, "*** WM_KEYUP ***");
	else
	{
		for (int x=0; x<19; ++x)
		{
			CString s = m_stringArray.GetAt(x+1);
			m_stringArray.SetAt(x, s);
		}
		m_stringArray.SetAt(19, "*** WM_KEYUP ***");
	}

	Invalidate();

	CView::OnKeyUp(nChar, nRepCnt, nFlags);
}
